import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import React from 'react';
import useDataProviderFetch from './useDataProviderFetch';

function noop() {}

export default function createDataProvider() {
  var FoundationDataProviderContext = /*#__PURE__*/React.createContext({
    fetch: function () {
      var _fetch = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      function fetch() {
        return _fetch.apply(this, arguments);
      }

      return fetch;
    }(),
    result: {
      state: 'fetching-initial'
    },
    update: noop
  });

  function FoundationDataProvider(_ref) {
    var children = _ref.children,
        fetchData = _ref.fetchData,
        initialFetchDataOptions = _ref.initialFetchDataOptions;
    var context = useDataProviderFetch({
      fetchData: fetchData,
      initialFetchDataOptions: initialFetchDataOptions
    });
    return /*#__PURE__*/React.createElement(FoundationDataProviderContext.Provider, {
      value: context
    }, children);
  }

  function FoundationDataConsumer(_ref2) {
    var children = _ref2.children;
    return /*#__PURE__*/React.createElement(FoundationDataProviderContext.Consumer, null, function (context) {
      return children(context);
    });
  }

  function FoundationDataProsumer(props) {
    var children = props.children,
        providerProps = _objectWithoutProperties(props, ["children"]);

    return /*#__PURE__*/React.createElement(FoundationDataProvider, providerProps, /*#__PURE__*/React.createElement(FoundationDataConsumer, null, children));
  }

  function useDataProvider() {
    return React.useContext(FoundationDataProviderContext);
  }

  return {
    FoundationDataConsumer: FoundationDataConsumer,
    FoundationDataProsumer: FoundationDataProsumer,
    FoundationDataProvider: FoundationDataProvider,
    useDataProvider: useDataProvider
  };
}
//# sourceMappingURL=createDataProvider.js.map