import dataFetchedError from './dataFetchedError';

import type {
    FoundationDataProviderResult,
} from './types';


interface TestData {
    text1: string;
    text2: string;
}


test('should include errors in error-initial state', () => {
    const result: FoundationDataProviderResult<TestData> = {
        state: 'fetching-initial',
    };

    const errors = { '__all__': [['context', 'message']] };
    const callback = dataFetchedError(errors);

    const newResult = callback(result);

    expect(newResult).toEqual({
        errors,
        state: 'error-initial',
    });
});

test('should include errors in error state', () => {
    const data = {
        text1: '#1',
        text2: '#2',
    };

    const result: FoundationDataProviderResult<TestData> = {
        data,
        state: 'fetching',
    };

    const errors = { '__all__': [['context', 'message']] };
    const callback = dataFetchedError(errors);

    const newResult = callback(result);

    expect(newResult).toEqual({
        data,
        errors,
        state: 'error',
    });
});
