import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import React from 'react';
import { makeCancelablePromise } from '@billogram/cancelable-promise';
import dataFetched from './dataFetched';
import dataFetchedError from './dataFetchedError';
import dataUpdate from './dataUpdate';

function noop() {}

export default function useDataProviderFetch(_ref) {
  var fetchData = _ref.fetchData,
      initialFetchDataOptions = _ref.initialFetchDataOptions;
  var cancel = React.useRef(noop);

  var _React$useState = React.useState({
    state: 'fetching-initial'
  }),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      result = _React$useState2[0],
      setResult = _React$useState2[1];

  var fetch = React.useCallback( /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(options) {
      var _makeCancelablePromis, _makeCancelablePromis2, newRequest, newCancel, token, _token, errors;

      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.prev = 0;
              cancel.current();
              setResult(function (result) {
                switch (result.state) {
                  case 'error-initial':
                  case 'fetching-initial':
                    {
                      return {
                        state: 'fetching-initial'
                      };
                    }

                  default:
                    {
                      return {
                        data: result.data,
                        state: 'fetching'
                      };
                    }
                }
              });
              _makeCancelablePromis = makeCancelablePromise(fetchData(options)), _makeCancelablePromis2 = _slicedToArray(_makeCancelablePromis, 2), newRequest = _makeCancelablePromis2[0], newCancel = _makeCancelablePromis2[1];
              cancel.current = newCancel;
              _context.next = 7;
              return newRequest;

            case 7:
              token = _context.sent;

              if (!token.isPromiseCanceled) {
                setResult(dataFetched(token.value));
              }

              _context.next = 15;
              break;

            case 11:
              _context.prev = 11;
              _context.t0 = _context["catch"](0);
              _token = _context.t0;

              if (!_token.isPromiseCanceled) {
                // eslint-disable-next-line @typescript-eslint/no-unnecessary-condition
                errors = _token.reason !== void 0 && _token.reason.data !== void 0 ? _token.reason.data : {};
                setResult(dataFetchedError(errors));
              }

            case 15:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[0, 11]]);
    }));

    return function (_x) {
      return _ref2.apply(this, arguments);
    };
  }(), [fetchData]);
  var update = React.useCallback(function (data) {
    setResult(dataUpdate(data));
  }, []);
  React.useEffect(function () {
    fetch(initialFetchDataOptions);
    return function () {
      cancel.current();
      cancel.current = noop;
    };
  }, [fetch, initialFetchDataOptions]);
  return React.useMemo(function () {
    return {
      fetch: fetch,
      result: result,
      update: update
    };
  }, [fetch, result, update]);
}
//# sourceMappingURL=useDataProviderFetch.js.map